hwe kernel to fix btrfs-send bug
[automated-distro-installer] / fai-redep
index 9a455c9c0cc6d01f30e8b0a0469e6c18a22fbc1a..3e1263d39551582d085adb46560588389ec20b68 100755 (executable)
--- a/fai-redep
+++ b/fai-redep
@@ -1,4 +1,4 @@
-#!/bin/bash -l
+#!/bin/bash
 # Copyright (C) 2016 Ian Kelling
 
 # This program is free software; you can redistribute it and/or
@@ -21,8 +21,11 @@ x="$(readlink -f "$BASH_SOURCE")"; cd ${x%/*}
 
 usage() {
     cat <<EOF
-usage: ${0##*/} [-h|--help] [HOST]
+usage: ${0##*/} [-h|--help] [HOST] [DISTRO]
 Deploy fai config (the one in nfs) to HOST or default faiserver
+Specify DISTRO for setting up DESKTOP packages.
+
+Note: uses paths specific to authors machine.
 EOF
     exit $1
 }
@@ -31,21 +34,21 @@ case $1 in
 esac
 
 host=${1:-faiserver}
-
+distro=$2
 
 # i use faiserver as a dns alias, but ssh key is associated with
 # a canonical hostname and we will have ssh warning spam unless we
 # use it, so look it up just to avoid the warning spam.
 faiserver_host=$(chost $host) || faiserver_host=$host
 
-rsync -rl --delete --relative --exclude /fai/config/basefiles/ fai/config root@$faiserver_host:/srv
+rsync -rlpt --delete --relative --exclude /fai/config/basefiles/ fai/config root@$faiserver_host:/srv
 
 
-scp -q ~/.ssh/id_rsa.pub \
+scp -q ~/.ssh/home.pub \
     root@$faiserver_host:/srv/fai/config/files/root/.ssh/authorized_keys/GRUB_PC
 # todo: automatically disable faiserver after a period so
 # these files are not exposed.
-s scp -qr /q/root/luks /q/root/shadow \
+sudo scp -qr /q/root/luks /q/root/shadow \
   root@$faiserver_host:/srv/fai/config/distro-install-common
 
 # should tar ssh all the files, but these ones really justified it
@@ -53,25 +56,15 @@ tar -cz /p/c/machine_specific/*/filesystem/etc/ssh | \
   ssh root@$faiserver_host tar -xz -C /srv/fai/config/distro-install-common
 
 
-# built BELANOS basefile with mk-basefile -J BELENOS64. it's stored in
-# it's own repo which is published alongside this one called
-# fai-basefiles due to being a large binary file.
+. /a/bin/distro-setup/pkgs
+pall+=($(/a/bin/buildscripts/emacs -p; /a/bin/distro-setup/distro-pkgs $distro))
+{ echo PACKAGES install; echo "${pall[*]}"|sed 's/ /\n/g'; } | \
+  ssh root@$faiserver_host dd of=/srv/fai/config/package_config/DESKTOP 2>/dev/null ||: # broken pipe
 
-declare -A sums
-while read -r sum file; do
-    sums[$file]=$sum
-done < <(cat /a/bin/fai-basefiles/md5sums.txt)
 
-{ timeout 2 curl -s http://fai-project.org/download/basefiles/md5sums.txt ||:; } |
-  while read -r sum file; do
-      if [[ ${sums[$file]} && ${sums[$file]} != $sum ]]; then
-        echo "${0##*/}: WARNING!!!!!!!!! NEW UPSTREAM BASEFILE: $file"
-      fi
-  done
-rsync -r --delete /a/bin/fai-basefiles/basefiles root@$faiserver_host:/srv/fai/config
+rsync -rplt --delete $BASEFILE_DIR/*.gz root@$faiserver_host:/srv/fai/config/basefiles/
 ssh root@$faiserver_host bash <<'EOF'
 set -eE -o pipefail
-set -x
 # make it the root because pxe-kexec only looks there.
 # It wouldn't be too hard to change if we needed.
 # We could also just dump things in /srv/tftp, but fai
@@ -81,21 +74,17 @@ sed -ri 's,^ *(TFTP_DIRECTORY=).*,\1"/srv/tftp/fai",' /etc/default/tftpd-hpa
 systemctl restart tftpd-hpa
 chmod 644 /srv/fai/config/files/root/.ssh/authorized_keys/GRUB_PC
 chmod -R a+rX /srv/fai/config/distro-install-common
-# this basefile has tar acls bug, so I'm using my own
-# local one for now.
-#cd /srv/fai/config/basefiles
-#u=http://fai-project.org/download/basefiles/XENIAL64.tar.xz
-#wget -nv -N $u
 
 changed=false
 f=/srv/fai/nfsroot/root/.ssh/known_hosts
+install -d -m 700 /srv/fai/nfsroot/root/.ssh
 # the known hosts entries that fai already sets up are like
 # IP,HOSTNAME key_info...
 # we are skipping the ip, because it doesn't block ssh
 # with a prompt as long as you have the user supplied hostname,
 # and i don't want to deal with getting it, it's not adding
 # any important security in this case.
-if ! grep -xFq "$line" $f; then
+if ! grep -xFq "$line" $f &>/dev/null; then
     changed=true
     printf "%s\n" "$line" >>$f
 fi